package actions;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import dataaccess.CustomerDAO;
import entity.CustomerEntity;
import forms.CustomerForm;

/**
 * @struts.action name="customerAF" path= "/customer"

 * @struts.action-forward name="customer" path="/jsps/customer.jsp"
 * @struts.action-forward name="customer.update" path="/jsps/customer.update.jsp"
 * @struts.action-forward name="customer.list" path="/jsps/customer.list.jsp"
 * @struts.action-forward name="error" path="/jsps/error.jsp"
 */
public class CustomerAction extends BaseAction{
    private CustomerEntity customerEntity;

    public ActionForward execute(ActionMapping actionMapping, ActionForm actionForm, HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws Exception {
        String actionName = httpServletRequest.getParameter("Action_Name");
        customerEntity = (CustomerEntity) makeEntityFromForm(actionForm);

//        System.out.println("================>>>>>>>>>>>>");
//        System.out.println(customerEntity.getName());
//        System.out.println(customerEntity.getFamily());
//        System.out.println("================>>>>>>>>>>>>");

        if( actionName.equalsIgnoreCase("add")) {

            return actionMapping.findForward("customer");

        } else if( actionName.equalsIgnoreCase("commitAdd")) {

            CustomerDAO.save(customerEntity);
            List list = CustomerDAO.list();
            httpServletRequest.getSession().setAttribute("CustomersList", list);
            return actionMapping.findForward("customer.list");

        } else if( actionName.equalsIgnoreCase("update")) {

            String ID = httpServletRequest.getParameter("ID");
            Long customerID = Long.decode(ID);

            CustomerEntity ce = (CustomerEntity) CustomerDAO.findByID(customerID);

            httpServletRequest.getSession().setAttribute("Customer", makeFormFromEntity( ce));
            httpServletRequest.getSession().setAttribute("ID", ID);

            return actionMapping.findForward("customer.update");

        } else if( actionName.equalsIgnoreCase("commitUpdate")) {

            Long ID = Long.decode((String)httpServletRequest.getSession().getAttribute("ID"));

            CustomerDAO.update(ID, customerEntity);

            List list = CustomerDAO.list();
            httpServletRequest.getSession().setAttribute("CustomersList", list);

            return actionMapping.findForward("customer.list");

        } else if( actionName.equalsIgnoreCase("list")) {

            List list = CustomerDAO.list();
            httpServletRequest.getSession().setAttribute("CustomersList", list);

            return actionMapping.findForward("customer.list");

        }

        return actionMapping.findForward("error");
    }

    protected Object makeEntityFromForm(ActionForm actionForm) {
        CustomerForm cf = (CustomerForm) actionForm;
        CustomerEntity ce = new CustomerEntity();

        ce.setName(cf.getName());
        ce.setFamily(cf.getFamily());

        return ce;
    }

    protected ActionForm makeFormFromEntity(Object o) {
        CustomerEntity ce = (CustomerEntity) o;
        CustomerForm cf = new CustomerForm();

        cf.setName(ce.getName());
        cf.setFamily(ce.getFamily());

        return cf;
    }
}
