package actions;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.sf.hibernate.Session;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.sessionfactory.sessionfactorymaker.MakeSessionFactory;

import dataaccess.TransportationDocumentDAO;
import entity.TransportationDocumentEntity;
import forms.TransportationDocumentForm;

/**
 * @struts.action name="transportationdocumentAF" path= "/transportationdocumentcrud"

 * @struts.action-forward name="transportationdocument" path="/jsps/transportationDocument.jsp"
 * @struts.action-forward name="transportationdocument.update" path="/jsps/transportationDocument.update.jsp"
 * @struts.action-forward name="transportationdocument.list" path="/jsps/transportationDocument.list.jsp"
 * @struts.action-forward name="error" path="/jsps/testerror.jsp"
 */
public class TransportationDocumentCRUDAction extends BaseAction
{
    private TransportationDocumentEntity transportationDocumentEntity;

    public ActionForward execute(ActionMapping actionMapping, ActionForm actionForm, HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws Exception {
        String actionName = httpServletRequest.getParameter("Action_Name");
        transportationDocumentEntity = ( TransportationDocumentEntity) makeEntityFromForm(actionForm);

//        System.out.println("================>>>>>>>>>>>>");
//        System.out.println(transportationDocumentEntity.getName());
//        System.out.println(transportationDocumentEntity.getFamily());
//        System.out.println("================>>>>>>>>>>>>");

        if( actionName.equalsIgnoreCase("add")) {

            return actionMapping.findForward("transportationDocument");

        } else if( actionName.equalsIgnoreCase("commitAdd")) {

            TransportationDocumentDAO.save(transportationDocumentEntity);
            List list = TransportationDocumentDAO.list();
            httpServletRequest.getSession().setAttribute("TransportationDocumentList", list);
            return actionMapping.findForward("transportationDocument.list");

        } else if( actionName.equalsIgnoreCase("update")) {

            String ID = httpServletRequest.getParameter("ID");
            Long transportationDocumentID = Long.decode(ID);

            TransportationDocumentEntity tde = (TransportationDocumentEntity) TransportationDocumentDAO.findByID(transportationDocumentID);

            httpServletRequest.getSession().setAttribute("TransportationDocument", makeFormFromEntity( tde));
            httpServletRequest.getSession().setAttribute("ID", ID);

            return actionMapping.findForward("transportationDocument.update");

        } else if( actionName.equalsIgnoreCase("commitUpdate")) {

            Long ID = Long.decode((String)httpServletRequest.getSession().getAttribute("ID"));

            TransportationDocumentDAO.update(ID, transportationDocumentEntity);

            List list = TransportationDocumentDAO.list();
            httpServletRequest.getSession().setAttribute("TransportationDocumentsList", list);

            return actionMapping.findForward("transportationDocument.list");

        } else if( actionName.equalsIgnoreCase("list")) {

            List list = TransportationDocumentDAO.list();
            httpServletRequest.getSession().setAttribute("TransportationDocumentsList", list);

            return actionMapping.findForward("transportationDocument.list");

        } else if( actionName.equalsIgnoreCase("test")) {

            Session session = MakeSessionFactory.getInstance().openSession();
            
            List retval = session.find("from PrincipalsEntity where PrincipalID='" + httpServletRequest.getParameter("j_username") + "'");
            httpServletRequest.getSession().setAttribute("Test", retval);
            
            session.close();

            return actionMapping.findForward("error");

        }

        return actionMapping.findForward("error");
    }

    protected Object makeEntityFromForm(ActionForm actionForm) 
    {
        TransportationDocumentForm tdForm = (TransportationDocumentForm) actionForm;
        TransportationDocumentEntity tdEntity = new TransportationDocumentEntity();

        tdEntity.setDate( tdForm.getDate());
//        tdEntity.setState( tdForm.getState());

        return tdEntity;
    }

    protected ActionForm makeFormFromEntity( Object o) 
    {
        TransportationDocumentEntity tdEntity = (TransportationDocumentEntity) o;
        TransportationDocumentForm tdForm = new TransportationDocumentForm();

        tdForm.setDate(tdEntity.getDate());
//        tdForm.setState(tdEntity.getState());

        return tdForm;
    }
}
