package dataaccess;

import net.sf.hibernate.Session;
import net.sf.hibernate.HibernateException;
import net.sf.hibernate.Transaction;

import java.util.Iterator;
import java.util.List;

import com.sessionfactory.sessionfactorymaker.MakeSessionFactory;

import entity.ProductionOrderEntity;
import entity.SentHavalehEntity;
import entity.TransportationDocumentEntity;


public class ProductionOrderDAO extends BaseDAO
{
    public static Long save(Object o) throws HibernateException 
	{
        Session session = MakeSessionFactory.getInstance().openSession();
        ProductionOrderEntity poe = (ProductionOrderEntity)o;

        Transaction transaction = session.beginTransaction();
        
        // ***** Hibernate Transaction *****
        session.save( poe);
        transaction.commit();
        // ***** Hibernate Transaction *****
        
        session.close();

        return poe.getID();
    }

    public static boolean update(Long ID, Object newo) throws HibernateException 
	{
        ProductionOrderEntity poe = ( ProductionOrderEntity)findByID(ID);

        if( poe == null)
            return false;

        ProductionOrderEntity no = ( ProductionOrderEntity)newo;

        poe.setDate( no.getDate());

        Session session = MakeSessionFactory.getInstance().openSession();

        Transaction transaction = session.beginTransaction();
        session.saveOrUpdate( poe);
        transaction.commit();
        
        session.close();

        return true;
    }

    public static boolean delete(Long ID) throws HibernateException 
	{
        ProductionOrderEntity poe = ( ProductionOrderEntity)findByID(ID);

        if( poe == null)
            return false;

        Session session = MakeSessionFactory.getInstance().openSession();

        Transaction transaction = session.beginTransaction();
        session.delete( poe);
        transaction.commit();
        
        session.close();

        return true;
    }

    public static List list() throws HibernateException {
        Session session = MakeSessionFactory.getInstance().openSession();
        
        List retval = session.find("from ProductionOrderEntity");
        
        session.close();

        return retval;
    }

    public static Object findByID(Long ID) throws HibernateException {
        Session session = MakeSessionFactory.getInstance().openSession();

        List productionOrders = session.find("from ProductionOrderEntity where ID=" + ID);
        
        session.close();

        if( productionOrders == null || productionOrders.size() == 0)
            return null;

        return productionOrders.get(0);
    }

	public static void order(List hlg2bp, ProductionOrderEntity productionOrderEntity, SentHavalehEntity she) throws HibernateException {
        Session session = MakeSessionFactory.getInstance().openSession();

        Transaction transaction = session.beginTransaction();
        
        for (Iterator iter = hlg2bp.iterator(); iter.hasNext();) {
			Object o = (Object) iter.next();
			session.saveOrUpdate(o);
		}
        
        session.saveOrUpdate(productionOrderEntity);
        
        session.saveOrUpdate(she);
        
        transaction.commit();
        
        session.close();
	}

	public static void transport(TransportationDocumentEntity transportationDocumentEntity, SentHavalehEntity she) throws HibernateException {
        Session session = MakeSessionFactory.getInstance().openSession();

        Transaction transaction = session.beginTransaction();
        
        session.saveOrUpdate(transportationDocumentEntity);
        
        session.saveOrUpdate(she);
        
        transaction.commit();
        
        session.close();		
	}
}
